with Interfaces.C;
with OCI.Thread;
package body OCI.Thick.Servers is

   ------------
   -- Attach --
   ------------

   function Attach (Name : String) return Server is
      H : OCIHandle := Alloc_Handle (Thread.Environment, OCI_HTYPE_SERVER);
      Rc : SWord := OCIServerAttach (OCIServer (H),
         Thread.Error, Interfaces.C.To_C (Name), Name'Length);
   begin
      Check_Error (RC);
      return (RF.Controlled_Reference with Handle => H,
                   Environment => Thread.Synch.Environment);
   exception
      when LIB_ERROR => 
         Free (H, OCI_HTYPE_SERVER);
         raise;
   end Attach;

   -----------
   -- Break --
   -----------

   procedure Break (It : Server)
   is
      Rc : SWord := OCIBreak (Handle (It), Thread.Error);
   begin
      Check_Error (RC);
   end Break;
   
   -----------
   -- Reset --
   -----------

   procedure Reset (It : Server)
   is
      Rc : SWord := OCIReset (Handle (It), Thread.Error);
   begin
      Check_Error (RC);
   end Reset;

   -------------
   -- Destroy --
   -------------

   procedure Destroy (It : in out Server) is
      Rc : SWord;
      use type OCI.Lib.OCIHandle;
   begin
      if It.Handle /= Empty_Handle then
         Rc := OCIServerDetach (OCIServer (It.Handle),
            Thread.Error);
         Free (It.Handle, OCI_HTYPE_SERVER);
      end if;
   end Destroy;

end OCI.Thick.Servers;

