with
   Ada.Text_IO,
   Ada.Integer_Text_IO,
   Ada.Long_Float_Text_IO,
   Ada.Strings.Unbounded,
   Ada.Exceptions,
   Oci.Thick,
   OCI.Thick.Integer_Var,
   OCI.Thick.OCIDate_Var,
   OCI.Thick.Long_Float_Var,
   OCI.Thick.OCINumber_Var,
   OCI.Thick.String_Var,
   OCI.Thick.String_Bounded,
   OCI.Thick.Servers,
   OCI.Thick.Connections,
   OCI.Thick.Statements,
   OCI.Thick.Parameters,
   OCI.Thick.Number_Functions,
   OCI.Thick.Debug_Allocation,
   OCI.Environments,
   OCI.Thick.Strings;
procedure Demo is
   use OCI.Thick;
   
   -- Using the OCI.Thick.Servers package.
   -- Creating server attachment.
   -- Empty name mean local server.
   Server : Servers.Server := Servers.Attach ("");
   
   -- Using the OCI.Thick.Connections package.
   -- Logon to the database and creating database connection
   Connect : Connections.Connection := Connections.Logon (
      DB => Server,
      User => "scott",
      Password => "tiger");
   
   -- We can create connection without previous server attached,
   -- Just spetsify the server name instead of server.
   Easy_Connect : Connections.Connection := Connections.Logon (
      Server_Name => "",
      User => "scott",
      Password => "tiger");

   Stmt_Text : String :=
      "select " &
         "OBJECT_NAME," &    --  VARCHAR2(128)
         "OBJECT_ID," &      --  NUMBER
         "DATA_OBJECT_ID," & --  NUMBER
         "OBJECT_TYPE," &    --  VARCHAR2(18)
         "CREATED," &        --  DATE
         "LAST_DDL_TIME," &  --  DATE
         "STATUS " &         --  VARCHAR2(7)
         "from user_objects where Generated = :P_Generated";

   -- Using the OCI.Thick.Statements package.
   -- Prepearing statement.
   -- OCI is prepearing statements without any communication with a server.
   Stmt : Statements.Statement := Statements.Prepare (Stmt_Text);
   
   --  Thick binding allow you to emulate ODBC like behavior of prepare.
   --  It looks like we are using connection for prepearing statement,
   --  but we are just remember Connection inside of Statement for the
   --  execute later.
   Stmt_2 : Statements.Statement := Statements.Prepare (Connect, Stmt_Text);
   
   Object_Name  :  Strings.Variable;
   Numb : OCINumber_Var.Variable;
   Date : OCIDate_Var.Variable;
   strb : String_Bounded.Variable (18);
   
begin
   -- We can see the server version information.
   Ada.Text_IO.Put_Line (
     Connections.Server_Version (Connect));
     
   

end Demo;